import pytest

from rtcvis import PLF, Point


@pytest.mark.parametrize(
    "a,b,expected",
    [
        (
            PLF([(0, 0), (2, 2)]),
            PLF([(0, 0), (1, 0.5), (2, 2.5)]),
            PLF([(0, 0), (1, 0.5), (2, -0.5)]),
        ),
        (
            PLF([(0, 0), (1, 1), (1, 0), (2, 1)]),
            PLF([(0, 1), (2, 3)]),
            PLF([(0, -1), (1, -1), (1, -2), (2, -2)]),
        ),
        (
            PLF([(0, 1), (4, 5), (8, 4)]),
            PLF([(0, 2), (2, 0), (5, 1), (8, -2)]),
            PLF([(0, -1), (2, 3), Point(4, 5 - 2 / 3), (5, 3.75), (8, 6)]),
        ),
        (
            PLF([(0, 2), (2, 0), (5, 1), (8, -2)]),
            PLF([(0, 2), (2, 0), (5, 1), (8, -2)]),
            PLF([(0, 0), (8, 0)]),
        ),
        (
            PLF([(-1, 0), (1, 2)]),
            PLF([(-1, 0), (0, 0), (0, 1), (1, 1)]),
            PLF([(-1, 0), (0, 1), (0, 0), (1, 1)]),
        ),
    ],
)
def test_plf_sub(a: PLF, b: PLF, expected: PLF):
    result = a - b
    assert result == expected
